<?php
/**
 * Joomla! 1.7 module mod_docebo_single_signon
 * @author Docebo
 * @package Joomla
 * @subpackage Docebo_single_signon
 * @license GNU General Public License version 2 or later; see LICENSE.txt
 */
// no direct access
defined('_JEXEC') or die;

class modDocebo_single_signonHelper {


	static public function check_sync_scene() {
		$db      = JFactory::getDbo();
		$tPrefix = $db->getPrefix() . 'docebo_general_settings';
		$db->setQuery("SELECT scenario FROM " . $tPrefix . " Limit 1");
		$sync_scene = $db->loadResult();

		return $sync_scene;
	}


	static public function get_sso_customs() {
		$getCust = '';
		$db      = JFactory::getDbo();
		$tPrefix = $db->getPrefix() . 'docebo_single_sign_on';
		$db->setQuery("SELECT * FROM " . $tPrefix . " Limit 1");
		$getCust = $db->loadAssoc();

		return $getCust;
	}
}

//------------------------------------------------------------------------------------
global $url, $key, $sso, $secret_key, $getset;

class ApiSingOn extends JViewLegacy {
	static public $totalmembers;

	static public function getSet() {
		$db      = JFactory::getDbo();
		$tPrefix = $db->getPrefix() . 'docebo_general_settings';
		$db->setQuery("SELECT * FROM " . $tPrefix . " Limit 1");
		$general_settings = $db->loadAssoc();

		//print_r($general_settings);
		return $general_settings;
	}

	static public function getHash($params) {
		$getset     = self::getSet();
		$key        = $getset['api_key'];
		$secret_key = $getset['key'];

		$res           = array('sha1' => '', 'x_auth' => '');
		$res['sha1']   = sha1(implode(',', $params) . ',' . $secret_key);
		$res['x_auth'] = base64_encode($key . ':' . $res['sha1']);

		return $res;
	}

	static private function getDefaultHeader($x_auth) {
		$getset = self::getSet();
		$url    = $getset['cloud_address'];

		// Get the host/domain from the cloud URL
		$url = str_replace('https://', '', $url);
		$url = str_replace('http://', '', $url);
		$url = parse_url('http://' . $url, PHP_URL_HOST);


		return array("Host: " . $url, "Content-Type: multipart/form-data", 'X-Authorization: Docebo ' . $x_auth);
	}

	static public function call($action, $data_params) {
		$getset = self::getSet();
		$url    = trim($getset['cloud_address']);
		$url    = str_ireplace('http://', '', $url);
		$url    = str_ireplace('https://', '', $url);

		$key        = $getset['api_key'];
		$secret_key = $getset['key'];
		$sso        = $getset['sso'];
		if (!function_exists('curl_version')) {
			return FALSE;
		}
		$curl        = curl_init();
		$hash_info   = self::getHash($data_params);
		$http_header = self::getDefaultHeader($hash_info['x_auth']);
		$opt         = array(
			CURLOPT_URL            => $url . '/api/' . $action,
			CURLOPT_RETURNTRANSFER => 1,
			CURLOPT_HTTPHEADER     => $http_header,
			CURLOPT_POST           => 1,
			CURLOPT_POSTFIELDS     => $data_params,
			CURLOPT_CONNECTTIMEOUT => 5, // Timeout to 5 seconds
			CURLOPT_SSL_VERIFYPEER => FALSE,
			CURLOPT_SSL_VERIFYHOST => FALSE,
		);
		curl_setopt_array($curl, $opt);
		// $output contains the output string
		$output = curl_exec($curl);
		// it closes the session
		curl_close($curl);

		return $output;
	}

	/**
	 * @param $user JUser the user object for which to build the sso link
	 *
	 * @return string
	 */
	static public function sso($user) {
		$getset = self::getSet();
		$url    = trim($getset['cloud_address']);
		if (stripos($url, 'http://') === FALSE && stripos($url, 'https://') === FALSE)
			$url = 'http://' . $url;

		$sso = $getset['sso'];

			// Get an instance of the cache object
			$cache = JFactory::getCache();

			// Get the current user's ID so we can get his Docebo username through API
			$username = $cache->call(array('ApiSingOn', 'userToDoceboUser'), JFactory::getUser()->get('id'));

			$time = time();
			$token = md5(strtolower($username).','.$time.','.$sso);
			return $url . '/doceboLms/index.php?auth_regen=1&modname=login&op=confirm&login_user=' . urlencode($username) . '&time=' . $time . '&token=' . $token;
	}

	static public function userToDoceboUser($user) {

		// Get the Docebo username that is associated
		// with the currently logged in Joomla user
		// (through API)
		$params           = array(
			'ext_user'      => $user,
			'ext_user_type' => 'wordpress',
		);
		$apiResponse      = self::call('user/profile/', $params);
		$docebo_user_info = json_decode($apiResponse);

		if ($docebo_user_info && isset($docebo_user_info->userid))
			return $docebo_user_info->userid;

		$user = JFactory::getUser($user);
		if($user){
			return $user->username;
		}

		return $user;
	}
}

?>